<?php
  //Get a list of all the supplied users files
  function get_user_files($user){
    global $FOLDERS;
    $files = array();
    $owner = sha1($user["name"].$FOLDERS["UserSalt"]);
    $user_uploads = "uploads/".$owner."/";
    if(!is_dir($user_uploads)){
      if(!mkdir($user_uploads)){
        return array();
      }
    }
    foreach(scandir($user_uploads) as $folder){
      if($folder == ".." || $folder == ".") continue;
      $filename = "";
      foreach(scandir($user_uploads.$folder."/") as $item){
        if($folder == ".." || $folder == ".") continue;
        $filename = $item;
      }
      array_push($files, array(
        "name"     => $filename,
        "location" => $user_uploads.$folder."/".$filename,
        "file_id"  => $folder,
        "owner_id" => $owner,
        "owner"    => $user["name"]
      ));
    }
    $times = array();
    foreach($files as $file){
      array_push($times, filemtime($file["location"]));
    }
    array_multisort($times, SORT_DESC, $files);
    return $files;
  }
  
  //Gets the internal location of a file
  function get_file_location($file){
    $filename = "";
    $dir = get_file_folder($file);
    foreach(scandir($dir) as $item){
      if($item == ".." || $item == ".") continue;
      $filename = $item;
    }
    return $dir.$filename;
  }
  
  //Get space used by a user
  function get_used_space($user){
    $result = array("size" => 0, "count" => 0);
    foreach(get_user_files($user) as $file){
      $result["size"] += filesize($file["location"]);
      $result["count"] += 1;
    }
    return $result;
  }
  
  //Pretty print the file size with size units
  function pretty_file_size($size){
    if($size < 1024){
      return $size . " Bytes";
    }
    elseif($size < 1024*1024){
      return round($size/1024) . " KB";
    }
    elseif($size < 1024*1024*1024){
      return round($size/(1024*1024), 1) . " MB";
    }
    return $size . " Bytes";
  }
  
  //Checks if an upload already exists
  function upload_exists($file){
    return file_exists("uploads/".$file["owner_id"]."/") && file_exists("uploads/".$file["owner_id"]."/".$file["file_id"]."/");
  }
  
  //Gets the folder location for a file
  function get_file_folder($file){
    $dir = "uploads/".$file["owner_id"]."/".$file["file_id"]."/";
    return $dir;
  }
  
  //Checks if a user can view file
  function user_can_view_file($user, $file){
    return is_user_owner($user, $file) || is_file_public($file);
  }
  
  //Checks if the user is the owner of a file
  function is_user_owner($user, $file){
    global $FOLDERS;
    return $file["owner_id"] == sha1($user["name"].$FOLDERS["UserSalt"]);
  }
  
  //When public files are implemented this will check if a file is public
  function is_file_public($file){
    //TODO: Make public files work
    return false;
  }
?>